#from typing_extensions import Required
from rest_framework import serializers
from clvoucherApp.models import * 
############## HR%Managment%Module #################

class VoucherSerializer(serializers.ModelSerializer):
    branch_str = serializers.CharField(source="branch.name",default="",read_only=True)
    class Meta:
        model = Voucher
        fields="__all__"
    # def get_department_str(self,obj):
    #     return obj.job.name

class PatientVoucherSerializer(serializers.ModelSerializer):
    voucher_name = serializers.CharField(source="voucher.name",default="",read_only=True)
    #patient session data 
    #expires_at_time =  serializers.DateTimeField(source="expires_at",format="%I:%M %p",default="",read_only=True,default_timezone=None)
    #expires_at_date = serializers.DateTimeField(source="expires_at",format="%Y-%m-%d",default="",read_only=True)
    creation_time = serializers.DateTimeField(source="created_at",format="%I:%M %p",default="",read_only=True)
    creation_date = serializers.DateTimeField(source="created_at",format="%Y-%m-%d",default="",read_only=True)
    created_by_name = serializers.CharField(source="created_by.name",default="",read_only=True)
    class Meta:
        model = PatientVoucher
        fields="__all__"

class PatientVoucherCustomSerializer(serializers.ModelSerializer):
    pt_fullname = serializers.CharField(source="patient.fullname",default="",read_only=True)
    pt_code = serializers.CharField(source="patient.code",default="",read_only=True)
    pt_number_1 = serializers.CharField(source="patient.number_1",default="",read_only=True)
    voucher_name = serializers.CharField(source="voucher.name",default="",read_only=True)
    #patient session data 
    #expires_at_time =  serializers.DateTimeField(source="expires_at",format="%I:%M %p",default="",read_only=True,default_timezone=None)
    #expires_at_date = serializers.DateTimeField(source="expires_at",format="%Y-%m-%d",default="",read_only=True)
    creation_time = serializers.DateTimeField(source="created_at",format="%I:%M %p",default="",read_only=True)
    creation_date = serializers.DateTimeField(source="created_at",format="%Y-%m-%d",default="",read_only=True)
    created_by_name = serializers.CharField(source="created_by.name",default="",read_only=True)
    class Meta:
        model = PatientVoucher
        fields="__all__"


class CampaignSerializer(serializers.ModelSerializer):
    #branch_str = serializers.CharField(source="branch.name",default="",read_only=True)
    class Meta:
        model = Campaign
        fields="__all__"
'''
class EmpDeductionSerializer(serializers.ModelSerializer):
    creation_day= serializers.SerializerMethodField()
    creation_time= serializers.SerializerMethodField()
    created_at = serializers.DateTimeField(format="%H:%M,%Y-%m-%d",required=False)
    class Meta:
        model = EmpDeduction
        fields="__all__"
        read_only_fileds=("creation_day","creation_time")
    def get_creation_day(self, obj):
        return obj.created_at.strftime("%Y-%m-%d")
    def get_creation_time(self, obj):
        return obj.created_at.strftime("%I:%M %p")
    def to_representation(self, instance):
        obj = super().to_representation(instance)
        deduction_name = instance.deduction.name
        obj['deduction'] = deduction_name
        obj['action_name'] = deduction_name
        obj['created_by'] = instance.created_by.name
        #obj['created_by'] = instance.created_by.get_full_name() 
        return obj
#https://pynative.com/python-datetime-format-strftime/
class EmpEarningSerializer(serializers.ModelSerializer):
    creation_day= serializers.SerializerMethodField()
    creation_time= serializers.SerializerMethodField()
    class Meta:
        model = EmpEarning
        fields="__all__"
        read_only_fileds=("creation_day","creation_time")
    def get_creation_day(self, obj):
        return obj.created_at.strftime("%Y-%m-%d")
    def get_creation_time(self, obj):
        return obj.created_at.strftime("%I:%M %p")
    def to_representation(self, instance):
        obj = super().to_representation(instance)
        earning_name = instance.earning.name
        obj['earning'] = earning_name
        obj['action_name'] = earning_name
        obj['created_by'] = instance.created_by.name
        #obj['created_by'] = instance.created_by.get_full_name() 
        return obj
class EarningSerializer(serializers.ModelSerializer):
    class Meta:
        model = Earning
        fields="__all__"

class EmpSalarySerializer(serializers.ModelSerializer):
    class Meta:
        model = EmpSalary
        fields="__all__"
############## END HR%Managment%Module #################
############## HR%Reception%Module #################
class EmpAttendanceSerializer(serializers.ModelSerializer):
    check_in_time = serializers.TimeField(source='check_in')
    check_out_time = serializers.DateTimeField(source='check_out',format="%I:%M %p",default="")
    check_out_day = serializers.DateTimeField(source='check_out',format="%Y-%m-%d",default="",read_only=True)
    class Meta:
        model = EmpAttendance
        fields="__all__"
        read_only_fields = ("check_in_time","check_out_time")
    def to_representation(self, instance):
        obj = super().to_representation(instance)
        obj['emp'] = instance.emp.fullname
        obj['department'] = instance.emp.department.name
        obj['check_in_by'] = instance.check_in_by.get_full_name()
        obj['check_out_by'] = instance.check_out_by.get_full_name() if instance.check_out_by else ""
        obj['check_in'] = instance.check_in.strftime("%I:%M %p")
        return obj


class EmpAttendanceCustomSerializer(serializers.ModelSerializer):
    department_name = serializers.ReadOnlyField(source='emp.department.name')
    emp_name = serializers.ReadOnlyField(source='emp.fullname')
    emp_number_1 = serializers.ReadOnlyField(source='emp.number_1',default="")
    emp_number_2 = serializers.ReadOnlyField(source='emp.number_2',default="")
    class Meta:
        model = EmpAttendance
        fields =  ("id","emp","emp_name","emp_number_1","emp_number_2",
        "day","check_in","check_in_note","check_in_by","department_name",)
        
    def to_representation(self, instance):
        obj = super().to_representation(instance)
        #obj['emp'] = instance.emp.fullname
        obj['check_in_by'] = instance.check_in_by.get_full_name()
        obj['check_in'] = instance.check_in.strftime("%I:%M %p")
        return obj

############## END HR%Reception%Module #################


'''